      PROGRAM FUNKY
C     A trivial little program just to give the ZGEEV() routine in the
C     lapack library a run for its money.

      IMPLICIT NONE

      CHARACTER*1 JOBVL
      CHARACTER*1 JOBVR
      PARAMETER(JOBVL = 'N')
      PARAMETER(JOBVR = 'N')

      INTEGER N
      PARAMETER(N = 20)

      COMPLEX*16 MATRIX
      DIMENSION MATRIX(N,N)

      COMPLEX*16 EIGENVALUES
      DIMENSION EIGENVALUES(N)

      COMPLEX*16 LVEC
      DIMENSION LVEC(N,N)

      COMPLEX*16 RVEC
      DIMENSION RVEC(N,N)

      COMPLEX*16 WORK
      DIMENSION WORK(N*N)

      REAL*8 RWORK
      DIMENSION RWORK(2*N)

      INTEGER INFO

      INTEGER I
      INTEGER J

      COMPLEX*16 TWOPII
      PARAMETER(TWOPII = (0.0, 6.28318530718))

      REAL*8 INVSQRTN


      INVSQRTN = 1.0/SQRT(1.0*N)


      DO I = 1, N
         DO J = 1, N
            MATRIX(I,J) = INVSQRTN*EXP((TWOPII*(I-1)*(J-1))/N)
         END DO
      END DO


      INFO = 0
      CALL ZGEEV(JOBVL, JOBVR, N, MATRIX, N, 
     $     EIGENVALUES, LVEC, N, RVEC, N, 
     $     WORK, N*N, RWORK, INFO)



C     Interesting observation: Whatever the value of N the eigenvalues
C     are in {+1, =i, -1, -i}. N=2 gets {+1,-1} and then they get added
C     "anticlockwise, starting at +i" as N increases.
      IF (INFO .EQ. 0) THEN
         DO I = 1, N
            WRITE(*,*) EIGENVALUES(I)
         END DO
      ELSE
         WRITE(*,*) INFO
      END IF


      STOP
      END
